## needrestart 3.5

=== Makefile ===
LOCALEDIR=/usr/share/locale

all: mo-files
	cd perl && perl Makefile.PL PREFIX=$(PREFIX) INSTALLDIRS=vendor 
	cd perl && $(MAKE)

install: all
	cd perl && $(MAKE) install
	
	mkdir -p "$(DESTDIR)/etc/needrestart/hook.d"
	cp hooks/* "$(DESTDIR)/etc/needrestart/hook.d/"
	cp ex/needrestart.conf "$(DESTDIR)/etc/needrestart/"
	cp ex/notify.conf "$(DESTDIR)/etc/needrestart/"
	cp ex/iucode.sh "$(DESTDIR)/etc/needrestart/"
	mkdir -p "$(DESTDIR)/etc/needrestart/conf.d"
	cp ex/conf.d/* "$(DESTDIR)/etc/needrestart/conf.d/"
	mkdir -p "$(DESTDIR)/etc/needrestart/notify.d"
	cp ex/notify.d/* "$(DESTDIR)/etc/needrestart/notify.d/"
	mkdir -p "$(DESTDIR)/etc/needrestart/restart.d"
	cp ex/restart.d/* "$(DESTDIR)/etc/needrestart/restart.d/"
	
	which apt-get > /dev/null && \
	    mkdir -p "$(DESTDIR)/etc/apt/apt.conf.d" && cp ex/apt/needrestart-apt_d "$(DESTDIR)/etc/apt/apt.conf.d/99needrestart" && \
	    mkdir -p "$(DESTDIR)/etc/dpkg/dpkg.cfg.d" && cp ex/apt/needrestart-dpkg_d "$(DESTDIR)/etc/dpkg/dpkg.cfg.d/needrestart" && \
	    mkdir -p "$(DESTDIR)/usr/lib/needrestart" && cp ex/apt/dpkg-status ex/apt/apt-pinvoke "$(DESTDIR)/usr/lib/needrestart" || true
	
	which debconf > /dev/null && \
	    mkdir -p "$(DESTDIR)/usr/share/needrestart" && \
	    po2debconf ex/debconf/needrestart.templates > "$(DESTDIR)/usr/share/needrestart/needrestart.templates" || true
	
	mkdir -p "$(DESTDIR)/usr/share/polkit-1/actions"
	cp ex/polkit/net.fiasko-nw.needrestart.policy "$(DESTDIR)/usr/share/polkit-1/actions/"
	
	mkdir -p "$(DESTDIR)/usr/sbin"
	cp needrestart "$(DESTDIR)/usr/sbin/"
	
	mkdir -p "$(DESTDIR)/usr/lib/needrestart"
	cp lib/iucode-scan-versions "$(DESTDIR)/usr/lib/needrestart/"
	cp lib/vmlinuz-get-version "$(DESTDIR)/usr/lib/needrestart/"
	cp lib/notify.d.sh "$(DESTDIR)/usr/lib/needrestart/"
	
	mkdir -p "$(DESTDIR)$(LOCALEDIR)"
	cp -r po/.build/* "$(DESTDIR)$(LOCALEDIR)/"

clean:
	[ ! -f perl/Makefile ] || ( cd perl && $(MAKE) realclean )
	rm -rf po/.build


pot-files: po/debconf/templates.pot po/needrestart/messages.pot po/needrestart-notify/messages.pot

po/debconf/templates.pot: ex/debconf/needrestart.templates
	cd ex/debconf && debconf-updatepo
	touch -r $+ $@

po/needrestart/messages.pot: needrestart $(wildcard perl/lib/NeedRestart/Kernel/*.pm wildcard perl/lib/NeedRestart/UI/*.pm)
	xgettext -o $@ --msgid-bugs-address=thomas@fiasko-nw.net \
	    --from-code=UTF-8 \
	    --package-name=needrestart --package-version=2.12 \
	    --keyword --keyword='$$__' --keyword=__ --keyword=__x \
	    --keyword=__n:1,2 --keyword=__nx:1,2 --keyword=__xn \
	    --keyword=N__ --language=perl $^

po/needrestart-notify/messages.pot: ex/notify.d/*-*
	xgettext -o $@ --msgid-bugs-address=thomas@fiasko-nw.net \
	    --package-name=needrestart-notify --package-version=2.12 \
	    --language=shell $^


mo-files:
	$(MAKE) -C po/needrestart
	$(MAKE) -C po/needrestart-notify

=== debian/changelog ===
needrestart (3.5-5ubuntu2.5) jammy; urgency=medium

  * Make stdio noninteractive if DEBIAN_FRONTEND='noninteractive'
    (LP: #2004203)
    - d/p/0001-UI-Make-stdio-noninteractive-if-DEBIAN_FRONTEND-noni.patch:
      Cherrypick of upstream pull request 214
    - Drop d/p/168.patch (upstream pull request 168) which was an
      incomplete fix supersided by PR 214.

 -- Zachary Raines <zachary.raines@canonical.com>  Wed, 10 Sep 2025 19:15:59 +0000

needrestart (3.5-5ubuntu2.4) jammy-security; urgency=medium

  * SECURITY REGRESSION: false positives for killing processes in LXC
    (LP: #2089193)
    - debian/patches/lp2091096/0021-fix-lxc-fp.patch: use the value of exe
      to check for obsolete processes when exec is undefined 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Thu, 05 Dec 2024 17:28:38 +0530

needrestart (3.5-5ubuntu2.3) jammy-security; urgency=medium

  * SECURITY REGRESSION: false positives for killing processes (LP: #2089193)
    - debian/patches/lp2089193/0020-fix-chroot-mountns-fp.patch: ignore check
      for obsolete processes in chrooted or containerized processes

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Tue, 26 Nov 2024 10:48:34 +0530

needrestart (3.5-5ubuntu2.2) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect usage of PYTHONPATH environment variable
    - debian/patches/CVE-2024-48990.patch: chdir to a clean directory 
      to avoid loading arbirary objects, sanitize PYTHONPATH before
      spawning a new python interpreter
    - CVE-2024-48990
  * SECURITY UPDATE: race condition for checking path to python
    - debian/patches/CVE-2024-48991.patch: sync path for both check
      and usage for python interpreter
    - CVE-2024-48991
  * SECURITY UPDATE: incorrect usage of RUBYLIB environment variable
    - debian/patches/CVE-2024-48992.patch: chdir to a clean directory
      to avoid loading arbirary objects, sanitize RUBYLIB before
      spawning a new ruby interpreter
    - CVE-2024-48992
  * SECURITY UPDATE: incorrect usage of Perl ScanDeps
    - debian/patches/CVE-2024-11003.patch: remove usage of ScanDeps
      to avoid parsing arbitrary code
    - CVE-2024-11003 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Mon, 18 Nov 2024 13:51:23 +0530

needrestart (3.5-5ubuntu2.1) jammy-security; urgency=medium

  * SECURITY UPDATE: arbitrary code exec via unanchored regexes
    - debian/patches/CVE-2022-30688.patch: improve regexes in
      perl/lib/NeedRestart/Interp/Perl.pm,
      perl/lib/NeedRestart/Interp/Python.pm,
      perl/lib/NeedRestart/Interp/Ruby.pm.
    - CVE-2022-30688

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 16 May 2022 07:08:25 -0400

needrestart (3.5-5ubuntu2) jammy; urgency=medium

  * d/p/Jammy-update-to-git*: Update needrestart from git (LP: #1965090)
    - fixes handling with cgroupv2 for docker and lxd (LP: #1964445)
    - adds detection of qemu VMs using outdated libs
    - various minor fixes

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 16 Mar 2022 08:53:23 +0100

needrestart (3.5-5ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Cherrypick pull request 168 to ensure that when installing packages
      noninteractively needrestart does not ask questions and operates in
      batch mode.
  * Dropped changes, included in Debian:
    - debian/tests/sanity-test.sh: add a simple sanity autopkgtest checking
      for basic needrestart output and functionality. Closes: #810584

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 15 Nov 2021 13:38:42 -0800

needrestart (3.5-5) unstable; urgency=medium

  * Add patch from Lukasz Zemczak to add and basic autopkgtest.
    Closes: #810584
  * Bump Standards-Version to 4.6.0.
  * Remove again pacman hook configfile.
    Closes: #994407

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 14 Oct 2021 14:23:58 +0200

needrestart (3.5-4ubuntu2) impish; urgency=medium

  * Cherrypick pull request 168 to ensure that when installing packages
    noninteractively needrestart does not ask questions and operates in
    batch mode.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 02 Jun 2021 09:36:49 +0100

needrestart (3.5-4ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/tests/sanity-test.sh: add a simple sanity autopkgtest checking
      for basic needrestart output and functionality. Closes: #810584

 -- Brian Murray <brian@ubuntu.com>  Thu, 20 May 2021 14:25:40 -0700

needrestart (3.5-4) unstable; urgency=medium

  * New source only upload.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 12 Apr 2021 10:04:21 +0200

needrestart (3.5-3) unstable; urgency=medium

  * debian/watch: Adjust github URL.
  * Add stable upstream patch 02-ruby-relative-path to fix detection for ruby
    script started from relative paths.
  * Add stable upstream patch 03-fix-wrong-default-comment to fix comment for
    default value of skip_mapfiles.
  * Add stable upstream patch 04-verbose-and-verbosity-confusion to fix
    verbose/verbosity confusion in needrestart.conf.
  * Add stable upstream patch 05-ignore-nvidia-memfd to ignore memfd used by
    nvidia binary drivers.
  * Add stable upstream patch 06-dont-restart-bluetooth to ignore restarting
    bluetooth by default.
  * Add stable upstream patch 07-runit to add support for runit.
    Closes: #972685

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 09 Apr 2021 11:17:52 +0200

needrestart (3.5-2ubuntu2) hirsute; urgency=medium

  * debian/tests/sanity-test.sh: only check for kernel output when not running
    in a container.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Tue, 23 Mar 2021 12:47:33 +0100

needrestart (3.5-2ubuntu1) hirsute; urgency=medium

  * debian/tests/sanity-test.sh: add a simple sanity autopkgtest checking for
    basic needrestart output and functionality.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 05 Mar 2021 18:01:10 +0100



=== debian/control ===
Source: needrestart
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper-compat (= 13),
 po-debconf,
 libmodule-find-perl
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://github.com/liske/needrestart

Package: needrestart
Architecture: all
Depends: ${misc:Depends},
 ${perl:Depends},
 dpkg (>= 1.16.0),
 gettext-base,
 libintl-perl,
 libproc-processtable-perl,
 libsort-naturally-perl,
 libmodule-scandeps-perl,
 libterm-readkey-perl,
 libmodule-find-perl,
 binutils,
 xz-utils
Recommends: libpam-systemd | sysvinit-core
Suggests: needrestart-session | libnotify-bin,
 iucode-tool
Enhances: intel-microcode
Description: check which daemons need to be restarted after library upgrades
 needrestart checks which daemons need to be restarted after library upgrades.
 It is inspired by checkrestart from the debian-goodies package.
 .
 Features:
  - supports (but does not require) systemd
  - binary blacklisting (i.e. display managers)
  - tries to detect required restarts of interpreter based daemons
    (supports Java, Perl, Python, Ruby)
  - tries to detect required restarts of containers (docker, LXC)
  - tries to detect pending kernel upgrades
  - tries to detect pending microcode upgrades for Intel CPUs
  - could be used as nagios check_command
  - fully integrated into apt/dpkg using hooks

=== debian/tests/control ===
Tests: sanity-test.sh
Restrictions: needs-root
Depends: needrestart, dpkg-dev

=== debian/watch ===
version=4
https://github.com/liske/needrestart/releases \
/liske/needrestart/archive/refs/tags/v(.+)\.tar\.gz

## needrestart 3.6

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 LOCALEDIR=/usr/share/locale
 
 all: mo-files
-	cd perl && perl Makefile.PL PREFIX=$(PREFIX) INSTALLDIRS=vendor 
+	cd perl && perl Makefile.PL PREFIX=$(PREFIX) INSTALLDIRS=vendor
 	cd perl && $(MAKE)
 
 install: all

=== debian/changelog ===
needrestart (3.6-7ubuntu4) noble; urgency=medium

  * d/p/ubuntu-avoid-restart-cloud-final.patch:
    - avoid automatic restart of cloud-init systemd oneshot services when
      cloud-init invokes apt-get dist-upgrade due to user-data (LP: #2059337)

 -- Chad Smith <chad.smith@canonical.com>  Wed, 27 Mar 2024 16:51:58 -0600

needrestart (3.6-7ubuntu3) noble; urgency=medium

  * debian/tests:
    - prompt-reboot: mark the tests as needing a VM since needrestart doesn't
      do kernel detection when within a container
    - *.py: migrate off some deprecated libtmux APIs
    - *.py: make tests less sensible to performance issues on the runners

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 08 Mar 2024 16:01:08 +0100

needrestart (3.6-7ubuntu2) noble; urgency=medium

  * Restore default behaviour wrt TTY detection.
    We're overriding it anyway later on in Ubuntu mode by default, unless a
    UI is explicitly given.
  * d/t/control: add missing libc6-dev dependency.
    We're building a small C helper to mock out uname(), and of course it
    needs the glibc headers available.
  * d/t: explicitly set the debconf frontend.
    autopkgtests set the frontend to noninteractive, but we actually want to
    test what happens with the default frontend to check that the flow
    doesn't get interrupted.

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 06 Mar 2024 14:41:27 +0100

needrestart (3.6-7ubuntu1) noble; urgency=medium

  * d/p/ubuntu-mode.patch: introduce a specific mode when running as APT hook.
    By default we want needrestart to be quieter, restart services that need
    it, and use the standard protocol to notify that a reboot is required.
    (LP: #1987449, LP: #2004203, LP: #2055433, LP: #2055437)

 -- Simon Chopin <schopin@ubuntu.com>  Thu, 29 Feb 2024 17:27:07 +0100

needrestart (3.6-7) unstable; urgency=high

  * Add patch 07-mark-unavailable-firmware-as-CURRENT to report missing
    firmware support as current.
    Closes: #1013285

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 12 Dec 2023 15:37:14 +0100

needrestart (3.6-6) unstable; urgency=high

  * Add upstream patch 05-fix-AMD-ucode-checking-in-non-debug-mode and
    06-uCode-fix-uninitialized-value-in-logging-of-processo to fix the check of
    microprocessor upgrades. Thanks to Antoine Beaupré!
    Closes: #1013285

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 20 Nov 2023 09:46:59 +0100

needrestart (3.6-5) unstable; urgency=medium

  * Remove obsolete NEWS file.
  * Merge 3.5-4+deb11u3 changelog.
  * Remove dependency on binutils.
    Closes: #1038621

 -- Patrick Matthäi <pmatthaei@debian.org>  Sun, 02 Jul 2023 16:26:12 +0200

needrestart (3.6-4) unstable; urgency=medium

  * Remove leftover conffile 30-pacman with 3.6-4.
    Closes: #1036526
  * Add patch 03-ignore-serial-getty from Helmut Grohne to ignore serial-getty.
    Closes: #1035721
  * Add upstream patch 04-vm-detection to fix a typo, which prevents the VM and
    microcode detection.
    Closes: #1026026

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 31 May 2023 16:47:03 +0200

needrestart (3.6-3) unstable; urgency=medium

  * Adjust debian/watch to work again with GitHub.
  * Bump Standards-Version to 4.6.2.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 12 Jan 2023 11:08:33 +0100

needrestart (3.6-2) unstable; urgency=medium

  * Merge 3.5-4+deb11u2 changelog.
  * Adjust renamed lintian tag name in override.
  * Add patch 02-bash-term-in-posix-shell to fix a bashism.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 14 Sep 2022 14:37:50 +0200

needrestart (3.6-1) unstable; urgency=high

  * New upstream release.
    - Drop merged patch 02-ruby-relative-path.
    - Drop merged patch 03-fix-wrong-default-comment.
    - Drop merged patch 04-verbose-and-verbosity-confusion.
    - Drop merged patch 05-ignore-nvidia-memfd.
    - Drop merged patch 06-dont-restart-bluetooth.
    - Drop merged patch 07-runit.
    - Fixes CVE-2022-30688: Not anchored regular expressions.
    - Replace strings(1) by GNU grep to drop binutils dependency.
      Closes: #986507
    - Fixes broken detection with cgroupv2.
      Closes: #1005953
    - Fixes microcode warnings without using systemd, also add systemd or
      libimvirt-perl as recommends.
      Closes: #984789
  * Bump Standards-Version to 4.6.1.
  * Merge 3.4-5+deb10u1 and 3.5-4+deb11u1 changelog.
  * Adjust mismatched lintian override.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 17 May 2022 17:38:05 +0200

needrestart (3.5-4+deb11u3) bullseye; urgency=medium

  * Add patch 10-amd-reporting from George Robbert to fix a Perl warning on
    AMD64 systems.
    Closes: #1026927

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 08 Feb 2023 12:20:03 +0100

needrestart (3.5-4+deb11u2) bullseye; urgency=medium

  * Add upstream patch 09-cgroupv2 to fix broken detection with cgroupv2.
    Closes: #1005953

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 18 May 2022 08:32:47 +0200

needrestart (3.5-4+deb11u1) bullseye-security; urgency=high

  * Add patch 08-anchor-interp-re to fix not anchored regular expressions.
    This fixes CVE-2022-30688.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 13 May 2022 10:50:07 +0200

needrestart (3.4-5+deb10u1) buster-security; urgency=high

  * Add patch 08-anchor-interp-re to fix not anchored regular expressions.
    This fixes CVE-2022-30688.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 13 May 2022 10:47:27 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
  po-debconf,
  libmodule-find-perl
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/liske/needrestart
 
@@ -22,9 +22,9 @@
  libmodule-scandeps-perl,
  libterm-readkey-perl,
  libmodule-find-perl,
- binutils,
  xz-utils
-Recommends: libpam-systemd | sysvinit-core
+Recommends: libpam-systemd | sysvinit-core,
+ systemd | libimvirt-perl
 Suggests: needrestart-session | libnotify-bin,
  iucode-tool
 Enhances: intel-microcode

=== debian/tests/control ===
Tests: sanity-test.sh
Restrictions: needs-root
Depends: needrestart, dpkg-dev

Tests: prompt-reboot.py
Restrictions: needs-root, isolation-machine
Depends: needrestart, tmux, python3-libtmux, gcc, libc6-dev, hello

Tests: prompt-services.py
Restrictions: needs-root
Depends: needrestart, tmux, python3-libtmux

## needrestart 3.7

=== debian/changelog ===
needrestart (3.7-2) unstable; urgency=medium

  * Patch 02-bash-term-in-posix-shell is not required with 3.7 anymore.
    Closes: #1078654

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 22 Aug 2024 14:03:01 +0200

needrestart (3.7-1) unstable; urgency=medium

  * New upstream release.
    - Drop merged patches 04-vm-detection,
      05-fix-AMD-ucode-checking-in-non-debug-mode,
      06-uCode-fix-uninitialized-value-in-logging-of-processo and
      07-mark-unavailable-firmware-as-CURRENT.
  * Bump Standards-Version to 4.7.0.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 13 Aug 2024 15:00:39 +0200

needrestart (3.6-8) unstable; urgency=medium

  * Merge 3.6-4+deb12u1 changelog.
  * Add patch 08-uninitialized-vars-arm from George Robbert to fix warnings on
    arm and some amd64 systems.
    Closes: #1063719
  * Add patch 09-recognize-versioned-ruby-interpreter from Helmut Grohne to
    detect also versioned ruby interpreters.
    Closes: #1063155
  * Add patch 10-notify-send-timeout from Michał Mirosław to fix a timeout in
    notify-send.
    Closes: #1024426
  * Add patch 11-spelling-error from David Weinehall to fix a spelling error.
    Closes: #1040673

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 03 Apr 2024 10:57:04 +0200

needrestart (3.6-4+deb12u1) bookworm; urgency=medium

  * fix microcode check regression on AMD CPUs (Closes: #1013285)

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 15 Nov 2023 15:05:37 -0500

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: needrestart
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
+Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Build-Depends: debhelper-compat (= 13),
  po-debconf,
  libmodule-find-perl
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/liske/needrestart

## needrestart 3.8

=== debian/changelog ===
needrestart (3.8-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 06 Mar 2025 10:10:54 +0100

needrestart (3.8-2) unstable; urgency=medium

  * Rename patch 11-core-fix-regression-of-false-positives-for-processes.
  * Add default overrides for qrtr-ns and rmtfs. Thanks to Arnaud Ferraris.
    Closes: #1095966

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 21 Feb 2025 17:12:27 +0100

needrestart (3.8-1) unstable; urgency=medium

  * Acknowledge all NMUs, thanks for taking care to everyone!
  * Uploading to unstable.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 23 Dec 2024 11:40:14 +0100

needrestart (3.8-0.1) experimental; urgency=medium

  * New upstream release (Closes: #1087882)
  * Remove patches merged upstream
    - 09-recognize-versioned-ruby-interpreter.diff
    - 11-spelling-error.diff
    - core-prevent-race-condition-on-proc-PID-exec-evaluat.patch
    - interp-chdir-into-empty-directory-to-prevent-python-.patch
    - interp-do-not-set-PYTHONPATH-environment-variable-to.patch
    - interp-do-not-set-RUBYLIB-environment-variable-to-pr.patch
    - interp-drop-usage-of-Module-ScanDeps-to-prevent-LPE.patch
  * 08-uninitialized-vars-arm.diff kept, but rerolled, seems like upstream
    had a different fix, might be unnecessary

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 09 Dec 2024 14:28:40 -0500

needrestart (3.7-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Revisit "core: fix regression of false positives for processes running in
    chroot or mountns" with final version upstream

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 28 Nov 2024 23:21:38 +0100

needrestart (3.7-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * core: fix regression of false positives for processes running in chroot or
    mountns (Closes: #1087918, #1088047, #1088012, #1087917, #1087958,
    #1087957)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 27 Nov 2024 20:45:40 +0100

needrestart (3.7-3.1) unstable; urgency=high

  * Non-maintainer upload.
  * Address local privilege escalation vulnerabilities from any unprivileged
    user to root (CVE-2024-48990, CVE-2024-48992, CVE-2024-48991,
    CVE-2024-11003):
    - core: prevent race condition on /proc/$PID/exec evaluation
    - interp: do not set PYTHONPATH environment variable to prevent a LPE
    - interp: do not set RUBYLIB environment variable to prevent a LPE
    - interp: chdir into empty directory to prevent python parsing arbitrary
      files
    - interp: drop usage of Module::ScanDeps to prevent LPE
  * debian/control: Drop Depends on libmodule-scandeps-perl

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 12 Nov 2024 20:31:52 +0100

needrestart (3.7-3) unstable; urgency=medium

  * Fix call of runuser in 400-notify-send.
    Closes: #1079666

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 01 Oct 2024 14:02:17 +0200

needrestart (3.6-4+deb12u3) bookworm-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * core: fix regression of false positives for processes running in chroot or
    mountns (Closes: #1087918, #1088047, #1088012, #1087917, #1087958,
    #1087957)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 02 Dec 2024 20:52:03 +0100

needrestart (3.6-4+deb12u2) bookworm-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Address local privilege escalation vulnerabilities from any unprivileged
    user to root (CVE-2024-48990, CVE-2024-48992, CVE-2024-48991,
    CVE-2024-11003):
    - core: prevent race condition on /proc/$PID/exec evaluation
    - interp: do not set PYTHONPATH environment variable to prevent a LPE
    - interp: do not set RUBYLIB environment variable to prevent a LPE
    - interp: chdir into empty directory to prevent python parsing arbitrary
      files
    - interp: drop usage of Module::ScanDeps to prevent LPE
  * debian/control: Drop Depends on libmodule-scandeps-perl

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 12 Nov 2024 20:51:08 +0100

needrestart (3.5-4+deb11u5) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * core: fix regression of false positives for processes running in chroot or
    mountns (Closes: #1087918, #1088047, #1088012, #1087917, #1087958,
    #1087957)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 02 Dec 2024 21:08:14 +0100

needrestart (3.5-4+deb11u4) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Address local privilege escalation vulnerabilities from any unprivileged
    user to root (CVE-2024-48990, CVE-2024-48992, CVE-2024-48991,
    CVE-2024-11003):
    - core: prevent race condition on /proc/$PID/exec evaluation
    - interp: do not set PYTHONPATH environment variable to prevent a LPE
    - interp: do not set RUBYLIB environment variable to prevent a LPE
    - interp: chdir into empty directory to prevent python parsing arbitrary
      files
    - interp: drop usage of Module::ScanDeps to prevent LPE
  * debian/control: Drop Depends on libmodule-scandeps-perl

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 14 Nov 2024 12:33:05 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,6 @@
  libintl-perl,
  libproc-processtable-perl,
  libsort-naturally-perl,
- libmodule-scandeps-perl,
  libterm-readkey-perl,
  libmodule-find-perl,
  xz-utils

## needrestart 3.9

=== debian/changelog ===
needrestart (3.9-1) unstable; urgency=medium

  * New upstream release.
    - Remove merged patch 11-core-fix-regression.
    - Added override for lxc.
      Closes: #1017417
    - Added override for xrdp.
      Closes: #1030843
    - Print executable in verbose mode.
      Closes: #1042008
  * Bump Standards-Version to 4.7.2.
  * Add apt to build depends.
    Closes: #1098809

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 28 Mar 2025 09:08:16 +0100

## needrestart 3.10

=== debian/changelog ===
needrestart (3.10-1) unstable; urgency=medium

  * New upstream release.
    - Remove merged patch 12-ignore-qrtr-rmtfs.
    - Add override for systemd-nspawn.
      Closes: #1101553
    - Unbreak systemd-user with dash.
      Closes: #1101551

 -- Patrick Matthäi <pmatthaei@debian.org>  Sun, 06 Apr 2025 18:30:24 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: optional
 Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Build-Depends: debhelper-compat (= 13),
+ apt,
  po-debconf,
  libmodule-find-perl
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/liske/needrestart

## needrestart 3.11

=== Makefile ===
--- 
+++ 
@@ -19,12 +19,12 @@
 	mkdir -p "$(DESTDIR)/etc/needrestart/restart.d"
 	cp ex/restart.d/* "$(DESTDIR)/etc/needrestart/restart.d/"
 	
-	which apt-get > /dev/null && \
+	command -v apt-get > /dev/null && \
 	    mkdir -p "$(DESTDIR)/etc/apt/apt.conf.d" && cp ex/apt/needrestart-apt_d "$(DESTDIR)/etc/apt/apt.conf.d/99needrestart" && \
 	    mkdir -p "$(DESTDIR)/etc/dpkg/dpkg.cfg.d" && cp ex/apt/needrestart-dpkg_d "$(DESTDIR)/etc/dpkg/dpkg.cfg.d/needrestart" && \
 	    mkdir -p "$(DESTDIR)/usr/lib/needrestart" && cp ex/apt/dpkg-status ex/apt/apt-pinvoke "$(DESTDIR)/usr/lib/needrestart" || true
 	
-	which debconf > /dev/null && \
+	command -v debconf > /dev/null && \
 	    mkdir -p "$(DESTDIR)/usr/share/needrestart" && \
 	    po2debconf ex/debconf/needrestart.templates > "$(DESTDIR)/usr/share/needrestart/needrestart.templates" || true
 	
@@ -41,6 +41,8 @@
 	
 	mkdir -p "$(DESTDIR)$(LOCALEDIR)"
 	cp -r po/.build/* "$(DESTDIR)$(LOCALEDIR)/"
+	
+	mkdir -p "$(DESTDIR)/var/cache/needrestart"
 
 clean:
 	[ ! -f perl/Makefile ] || ( cd perl && $(MAKE) realclean )

=== debian/changelog ===
needrestart (3.11-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2112044).
  * Remaining changes:
    - ubuntu-mode, with all subsequent changes squashed together:
      + introduce a specific mode when running as APT hook
        (LP #1987449, LP #2004203, LP #2055433, LP #2055437)
      + Don't touch /run/reboot-required on kernel updates
        (LP #2065863, LP #2068543, LP #2068573)
      + Fix container handling (LP #2084571)
        - make sure containers aren't restarted from APT
      + Restore default behaviour wrt TTY detection
      + d/t:
        - control: add missing libc6-dev dependency, mark tests
          needing VM.
        - explicitly set the debconf frontend.
        - move tests to Tests instead of Test-Command
        - deprecate APIs and runner performance
        - guard against looping when failing
        - move off deprecated python-tmux APIs (LP #2069591)
      + Add some inline documentation for the Ubuntu mode
        (LP #2068573)
    - d/p/ubuntu-avoid-restart-cloud-final.patch: avoid automatic
      restart of cloud-init systemd oneshot services when
      cloud-init invokes apt-get dist-upgrade due to user-data
    - Prevent needrestart restarting itself (LP #2067482)
    - restart exceptions for google-guest-agent service, GH
      runner provisioner, glusterd and keepalived
      (LP #2063442, LP #2067800, LP #2085070, LP #2089155)
    - d/p/lp2085070/0020-ubuntu-avoid-restart-glusterd.patch:
      Add regex to ignore glusterd for automatic restart
    - d/p/lp2089155/0021-ubuntu-avoid-restart-keepalived.patch:
      Add regex to ignore keepalived for automatic restart
  * Dropped changes:
    - d/p/lp2067482: drop part of patch as similar functionality
      was added upstream

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Tue, 03 Jun 2025 12:56:06 -0700

needrestart (3.11-1) unstable; urgency=medium

  * New upstream release.
  * Add procps as dependency.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 15 Apr 2025 13:48:01 +0200

needrestart (3.8-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2091347)
  * Drop changes:
    - d/p/CVE-2024-48990.patch: Fixed in 3.7-3.1
    - d/p/CVE-2024-48991.patch: Fixed in 3.7-3.1
    - d/p/CVE-2024-48992.patch: Fixed in 3.7-3.1
    - d/p/CVE-2024-11003.patch: Fixed in 3.7-3.1
    - d/p/lp2084571/*.patch: Fixed in 3.7
  * Remaining changes:
    - ubuntu-mode:
      + introduce a specific mode when running as APT hook
        (LP #1987449, LP #2004203, LP #2055433, LP #2055437)
      + Don't touch /run/reboot-required on kernel updates
        (LP #2065863, LP #2068543, LP #2068573)
      + Fix container handling (LP #2084571)
        - make sure containers aren't restarted from APT
        - Rest of the delta has been resolved upstream
      + Restore default behaviour wrt TTY detection
      + d/t:
        - control: add missing libc6-dev dependency, mark tests
          needing VM.
        - explicitly set the debconf frontend.
        - move tests to Tests instead of Test-Command
        - deprecate APIs and runner performance
        - guard against looping when failing
        - move off deprecated python-tmux APIs (LP #2069591)
      + Add some inline documentation for the Ubuntu mode
        (LP: #2068573)
    - d/p/ubuntu-avoid-restart-cloud-final.patch: avoid automatic
      restart of cloud-init systemd oneshot services when
      cloud-init invokes apt-get dist-upgrade due to user-data
    - Prevent needrestart restarting itself (LP #2067482)
    - restart exceptions for google-guest-agent service, GH
      runner provisioner, glusterd and keepalived
      (LP #2063442, LP #2067800, LP: #2085070, LP: #2089155)

 -- Pragyansh Chaturvedi <pragyansh.chaturvedi@canonical.com>  Thu, 16 Jan 2025 01:18:11 +0530

needrestart (3.6-8ubuntu7) plucky; urgency=medium

  * Don't restart glusterd automatically (LP: #2085070)
    - d/p/lp2085070/0020-ubuntu-avoid-restart-glusterd.patch:
      Add regex to ignore glusterd and for automatic restart
  * Don't restart keepalived automatically (LP: #2089155)
    - d/p/lp2089155/0021-ubuntu-avoid-restart-keepalived.patch:
      Add regex to ignore keepalived and for automatic restart

 -- Pragyansh Chaturvedi <pragyansh.chaturvedi@canonical.com>  Tue, 10 Dec 2024 13:22:02 +0530

needrestart (3.6-8ubuntu6) plucky; urgency=medium

  * SECURITY UPDATE: incorrect usage of PYTHONPATH environment variable
    - debian/patches/CVE-2024-48990.patch: chdir to a clean directory 
      to avoid loading arbirary objects, sanitize PYTHONPATH before
      spawning a new python interpreter
    - CVE-2024-48990
  * SECURITY UPDATE: race condition for checking path to python
    - debian/patches/CVE-2024-48991.patch: sync path for both check
      and usage for python interpreter
    - CVE-2024-48991
  * SECURITY UPDATE: incorrect usage of RUBYLIB environment variable
    - debian/patches/CVE-2024-48992.patch: chdir to a clean directory
      to avoid loading arbirary objects, sanitize RUBYLIB before
      spawning a new ruby interpreter
    - CVE-2024-48992
  * SECURITY UPDATE: incorrect usage of Perl ScanDeps
    - debian/patches/CVE-2024-11003.patch: remove usage of ScanDeps
      to avoid parsing arbitrary code
    - CVE-2024-11003

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Wed, 20 Nov 2024 20:22:52 +0530

needrestart (3.6-8ubuntu5) plucky; urgency=medium

  * Fix container handling (LP: #2084571)
    - d/p/ubuntu-mode.patch: make sure containers aren't restarted from APT
    - d/p/lp2084571/0019-container-fix-always-ignoring-lxc-lxd-instances-regr.patch:
      cherry-picked fix from upstream.

 -- Simon Chopin <schopin@ubuntu.com>  Tue, 15 Oct 2024 17:56:08 +0200

needrestart (3.6-8ubuntu4) oracular; urgency=medium

  * d/tests/*.py: move off deprecated python-tmux APIs (LP: #2069591)

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 19 Jun 2024 15:38:22 +0200

needrestart (3.6-8ubuntu3) oracular; urgency=medium



=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: needrestart
 Section: admin
 Priority: optional
-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Build-Depends: debhelper-compat (= 13),
  apt,
  po-debconf,
@@ -21,6 +22,7 @@
  libsort-naturally-perl,
  libterm-readkey-perl,
  libmodule-find-perl,
+ procps,
  xz-utils
 Recommends: libpam-systemd | sysvinit-core,
  systemd | libimvirt-perl

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp
	rm $(CURDIR)/debian/tmp/etc/needrestart/hook.d/30-pacman

=== debian/tests/control ===
--- 
+++ 
@@ -9,3 +9,7 @@
 Tests: prompt-services.py
 Restrictions: needs-root
 Depends: needrestart, tmux, python3-libtmux
+
+Tests: self-restart.sh
+Restrictions: needs-root
+Depends: needrestart, dpkg-dev

=== debian/watch ===
version=4
https://github.com/liske/needrestart/tags .*/v(\d\S+)\.tar\.gz
